System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, game, Sprite, toDegree, UITransform, _decorator, _dec, _dec2, _class, _temp, _crd, requireComponent, ccclass, TestTileComponent;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function distanceXY(ax, ay, bx, by) {
    const dx = bx - ax;
    const dy = by - ay;
    return Math.sqrt(dx * dx + dy * dy);
  }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      game = _cc.game;
      Sprite = _cc.Sprite;
      toDegree = _cc.toDegree;
      UITransform = _cc.UITransform;
      _decorator = _cc._decorator;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "cd632NSUABF2oe8+qUNoEzC", "TestTile", undefined);

      ({
        requireComponent,
        ccclass
      } = _decorator);
      ;

      _export("TestTileComponent", TestTileComponent = (_dec = ccclass("TestTile"), _dec2 = requireComponent(UITransform), _dec(_class = _dec2(_class = (_temp = class TestTileComponent extends Sprite {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_trans", void 0);
        }

        onLoad() {
          this._trans = this.getComponent(UITransform);
          this.type = Sprite.Type.TILED;
          this.sizeMode = Sprite.SizeMode.CUSTOM;

          this._trans.anchorPoint.set(0, .5);
        }

        castTo(worldX, worldY) {
          const x = this.node.worldPosition.x;
          const y = this.node.worldPosition.y;
          const w = worldX - x;
          const h = worldY - y;
          const len = distanceXY(x, y, worldX, worldY);
          const angle = Math.atan2(h, w);

          this._trans.contentSize.set(len, this._trans.contentSize.height);

          this.node.angle = toDegree(angle);
        }

        update(delta) {
          const p = this.node.worldPosition;
          this.castTo(p.x + Math.cos(game.totalTime * .001) * Math.random() * 200 + 100, p.y + Math.sin(game.totalTime * .001) * 300);
        }

      }, _temp)) || _class) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=TestTile.js.map